pro ncdf_read_MAR

MAR_dir='/raid3/umccb/clim0017/stulambin/caraib/out_MAR/'

out_dir='../clim/Madagascar/MAR/'

iyr1=2001
iyr2=2001

elv_thres = 0.05

res_MAR = 10.   ; MAR resolution (km)

xlgmin = 42.84
xlgmax = 51.14  
xltmin = -25.96 
xltmax = -11.44 

for iyr = iyr1, iyr2 do begin 

year=string(iyr,format='(i4)')
print,'Year:',year

;filename=MAR_dir+'ICE.'+year+'.01-12.NET3.nc'
filename=MAR_dir+'madagascar_'+year+'.nc'
print,'NETCDF file: ',filename

fileID=ncdf_open(filename)

file_struct=ncdf_inquire(fileID)
ndims=file_struct.ndims
print,'Number of Dimensions: ',ndims
nvars=file_struct.nvars
print,'Number of Variables: ',nvars
ngatts=file_struct.ngatts
print,'Number of Attributes: ',ngatts

name_dim=make_array(ndims,/string)
size_dim=make_array(ndims,/long)

for k=0,ndims-1 do begin
 ncdf_diminq,fileID,k,named,sized
 name_dim(k)=named
 size_dim(k)=sized
 print,k,' ',name_dim(k),' ',size_dim(k)
endfor


vname=make_array(nvars,/string)
vndims=make_array(nvars,/integer)
vdtype=make_array(nvars,/string)

for j=0,nvars-1 do begin
 res_varinq=ncdf_varinq(fileID,j)
 vname(j)=res_varinq.name
 vndims(j)=res_varinq.ndims
 vdtype(j)=res_varinq.datatype
 print,j,' ',vname(j),' ',vndims(j),' ',vdtype(j)
 if strtrim(vname(j),2) eq 'TIME' then jtime=j 
 if strtrim(vname(j),2) eq 'DATE' then jdate=j
 if strtrim(vname(j),2) eq 'LON' then jlon=j
 if strtrim(vname(j),2) eq 'LAT' then jlat=j
 if strtrim(vname(j),2) eq 'TTMIN' then jttmin=j
 if strtrim(vname(j),2) eq 'TTMAX' then jttmax=j
 if strtrim(vname(j),2) eq 'TT' then jtt=j
 if strtrim(vname(j),2) eq 'MBRR' then jrf=j     ; MBRR  ;RF
; if strtrim(vname(j),2) eq 'SF' then jsf=j     ; MBSF
 if strtrim(vname(j),2) eq 'RH' then jrh=j
 if strtrim(vname(j),2) eq 'UV' then juv=j
 if strtrim(vname(j),2) eq 'SWD' then jswd=j
; if strtrim(vname(j),2) eq 'SRF' then jsrf=j
 if strtrim(vname(j),2) eq 'SH' then jsh=j 
 if strtrim(vname(j),2) eq 'ATMLAY1_1' then jatml=j    ;ATMLAY
endfor


;aname=make_array(ngatts,/string)
;alength=make_array(ngatts,/integer)
;adtype=make_array(ngatts,/string)

;for i=0,ngatts-1 do begin
; aname(i)=ncdf_attname(fileID,vname(3),i)
; res_attinq=ncdf_attinq(fileID,vname(3),aname(i))
; alength(i)=res_attinq.length
; adtype(i)=res_attinq.datatype
; print,i,' ',aname(i),' ',alength(i),' ',adtype(i)
; ncdf_attget,fileID,vname(i),aname(i),value
; print,value
;endfor



ncdf_varget,fileID,jtime,time
ncdf_varget,fileID,jdate,date
ncdf_varget,fileID,jlon,lon
ncdf_varget,fileID,jlat,lat

ncdf_varget,fileID,jttmin,ttmin
ncdf_varget,fileID,jttmax,ttmax
ncdf_varget,fileID,jtt,tt
;ncdf_varget,fileID,jsf,sf
ncdf_varget,fileID,jrf,rf
ncdf_varget,fileID,jrh,rh
ncdf_varget,fileID,juv,uv
ncdf_varget,fileID,jswd,swd
;ncdf_varget,fileID,jsrf,srf
ncdf_varget,fileID,jsh,sh
ncdf_varget,fileID,jatml,atml

print,'Size of vectors:'
print,' time: ',size(time)
print,' date: ',size(date)
print,' lon: ',size(lon)
print,' lat: ',size(lat)

print,' ttmin: ',size(ttmin)
print,' ttmax: ',size(ttmax)
print,' tt: ',size(tt)
;print,' sf: ',size(sf)
print,' rf: ',size(rf)
print,' rh: ',size(rh)
print,' uv: ',size(uv)
print,' swd: ',size(swd)
;print,' srf: ',size(srf)
print,' sh: ',size(sh)
print,' atml: ',size(atml)


day_number=make_array(size_dim(0),/integer)
for k=0,size_dim(0)-1 do day_number(k) = k+1

ncdf_close,fileID

print,'End of netcdf file read'


for k=0,ndims-1 do begin 
 print,k,size_dim(k)
endfor 

ksf=0
sigmax=-999.
for k=0,size_dim(3)-1 do begin
 print,'ATMLAY(',k,') = ',atml(k)
 if sigmax lt atml(k) then begin
   sigmax =atml(k)
   ksf=k
 endif
endfor
print,'ksf = ',ksf


if iyr eq iyr1 then begin
 fileout=out_dir+'elev'+'.dat'
 close,19
 openw,19,fileout
endif

tasmin=make_array(size_dim(0),/float)
fileout=out_dir+'tmin'+year+'.dat'
close,20
openw,20,fileout

tasmax=make_array(size_dim(0),/float)
fileout=out_dir+'tmax'+year+'.dat'
close,21
openw,21,fileout

tas=make_array(size_dim(0),/float)
fileout=out_dir+'tem'+year+'.dat'
close,22
openw,22,fileout

prc=make_array(size_dim(0),/float)
fileout=out_dir+'prc'+year+'.dat'
close,23
openw,23,fileout

rhu=make_array(size_dim(0),/float)
fileout=out_dir+'rhu'+year+'.dat'
close,24
openw,24,fileout

wnd=make_array(size_dim(0),/float)
fileout=out_dir+'wnd'+year+'.dat'
close,25
openw,25,fileout

fsol=make_array(size_dim(0),/float)
fileout=out_dir+'fsol'+year+'.dat'
close,26
openw,26,fileout




for iy = 0, size_dim(2)-1 do begin
 for ix = 0, size_dim(1)-1 do begin
  elv=sh(ix,iy)
  fsol_tot=0.
  for idn = 0, size_dim(0)-1 do begin
;    tasmin(idn) = ttmin(ix,iy,ksf,idn)
;    tasmax(idn) = ttmax(ix,iy,ksf,idn)
    tasmin(idn) = ttmin(ix,iy,0,idn)
    tasmax(idn) = ttmax(ix,iy,0,idn)    
    tas(idn) = tt(ix,iy,ksf,idn)
    prc(idn) = rf(ix,iy,idn)       ;+sf(ix,iy,idn)
    rhu(idn) = rh(ix,iy,ksf,idn)
    wnd(idn) = uv(ix,iy,ksf,idn)
    fsol(idn) = swd(ix,iy,idn)
    fsol_tot=fsol_tot+fsol(idn)
  endfor
  latrad=lat(ix,iy)*3.14159265/180.
  reslon=cos(latrad)*res_MAR/111.1111
  reslat=res_MAR/111.1111
  if ((fsol_tot ge 4) and (elv ge elv_thres)) then begin
   if ((lon(ix,iy) gt (xlgmin+0.5*reslon)) and (lon(ix,iy) lt (xlgmax-0.5*reslon))) then begin
   if ((lat(ix,iy) gt (xltmin+0.5*reslat)) and (lat(ix,iy) lt (xltmax-0.5*reslat))) then begin  
    if iyr eq iyr1 then printf,19,lon(ix,iy),lat(ix,iy),sh(ix,iy),format='(f8.3,1x,f7.3,1x,f8.2)'
    printf,20,lon(ix,iy),lat(ix,iy),tasmin,format='(f8.3,1x,f7.3,366(1x,f6.2))'
    printf,21,lon(ix,iy),lat(ix,iy),tasmax,format='(f8.3,1x,f7.3,366(1x,f6.2))'
    printf,22,lon(ix,iy),lat(ix,iy),tas,format='(f8.3,1x,f7.3,366(1x,f6.2))'
    printf,23,lon(ix,iy),lat(ix,iy),prc,format='(f8.3,1x,f7.3,366(1x,f7.2))'
    printf,24,lon(ix,iy),lat(ix,iy),rhu,format='(f8.3,1x,f7.3,366(1x,f6.2))'
    printf,25,lon(ix,iy),lat(ix,iy),wnd,format='(f8.3,1x,f7.3,366(1x,f6.2))'
    printf,26,lon(ix,iy),lat(ix,iy),fsol,format='(f8.3,1x,f7.3,366(1x,f7.2))'
   endif
   endif
  endif
 endfor
endfor
if iyr eq iyr1 then close,19
close,20,21,22,23,24,25,26

endfor

print,'End of program'

return
end
